Index: palm/trunk/SOURCE/surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_mod.f90	(revision 2693)
+++ palm/trunk/SOURCE/surface_mod.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file surface_mod.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
@@ -26,4 +26,16 @@
 ! -----------------
 ! $Id$
+! - Missing code for css added to surf_*, handling of surface_csflux updated (FK)
+! - Bugfixes in reading/writing restart data in case several surface types are 
+!   present at the same time (MS)
+! - Implementation of chemistry module (FK)
+! - Allocation of pt1 and qv1 now done for all surface types (MS)
+! - Revised classification of surface types
+! - Introduce offset values to simplify index determination of surface elements
+! - Dimensions of function get_topo_top_index (MS)
+! - added variables for USM 
+! - adapted to changes in USM (RvT)
+! 
+! 2688 2017-12-12 17:27:04Z Giersch
 ! Allocation and initialization of the latent heat flux (qsws) at the top of 
 ! the ocean domain in case of coupled runs. In addtion, a double if-query has 
@@ -84,4 +96,8 @@
 !> In addition, a further derived data structure is defined, in order to set
 !> boundary conditions at surfaces.  
+!> @todo For the moment, downward-facing surfaces are only classified as  
+!>        default type 
+!> @todo Clean up urban-surface variables (some of them are not used any more) 
+!> @todo Revise chemistry surface flux part (reduce loops?!) 
 !------------------------------------------------------------------------------!
  MODULE surface_mod
@@ -91,4 +107,8 @@
                momentumflux_input_conversion
 
+#if defined( __chem )
+    USE chem_modules
+#endif
+
     USE control_parameters               
 
@@ -126,5 +146,9 @@
     TYPE surf_type
 
+       INTEGER(iwp) :: ioff                                !< offset value in x-direction, used to determine index of surface element
+       INTEGER(iwp) :: joff                                !< offset value in y-direction, used to determine index of surface element
+       INTEGER(iwp) :: koff                                !< offset value in z-direction, used to determine index of surface element
        INTEGER(iwp) :: ns                                  !< number of surface elements on the PE
+
        INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  i       !< x-index linking to the PALM 3D-grid  
        INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  j       !< y-index linking to the PALM 3D-grid    
@@ -154,6 +178,7 @@
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  z0q       !< roughness length for humidity
 
-       REAL(wp), DIMENSION(:), ALLOCATABLE ::  pt1       !< Specific humidity at first grid level (required for cloud_physics = .T. or cloud_droplets = .T.)
-       REAL(wp), DIMENSION(:), ALLOCATABLE ::  qv1       !< Potential temperature at first grid level (required for cloud_physics = .T. or cloud_droplets = .T.)
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  pt1       !< Potential temperature at first grid level
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  qv1       !< Specific humidity at first grid level
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  css     !< scaling parameter chemical species
 !
 !--    Define arrays for surface fluxes
@@ -169,4 +194,6 @@
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  nrsws     !< surface flux nr
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  sasws     !< surface flux salinity
+       
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  cssws   !< surface flux chemical species
 !
 !--    Required for horizontal walls in production_e
@@ -179,25 +206,52 @@
 !
 !--    Variables required for LSM as well as for USM
-       REAL(wp), DIMENSION(:), ALLOCATABLE   ::  pt_surface        !< skin-surface temperature
-       REAL(wp), DIMENSION(:), ALLOCATABLE   ::  rad_net_l         !< net radiation 
-       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  lambda_h          !< heat conductivity of soil (W/m/K) 
-       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  lambda_h_def      !< default heat conductivity of soil (W/m/K)   
-       
+       INTEGER(iwp), DIMENSION(:), ALLOCATABLE   ::  nzt_pavement  !< top index for pavement in soil
+       INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  albedo_type   !< albedo type, for each fraction (wall,green,window or vegetation,pavement water)
+
        LOGICAL, DIMENSION(:), ALLOCATABLE  ::  building_surface    !< flag parameter indicating that the surface element is covered by buildings (no LSM actions, not implemented yet)
+       LOGICAL, DIMENSION(:), ALLOCATABLE  ::  building_covered    !< flag indicating that buildings are on top of orography, only used for vertical surfaces in LSM
        LOGICAL, DIMENSION(:), ALLOCATABLE  ::  pavement_surface    !< flag parameter for pavements
        LOGICAL, DIMENSION(:), ALLOCATABLE  ::  water_surface       !< flag parameter for water surfaces
-       LOGICAL, DIMENSION(:), ALLOCATABLE  ::  vegetation_surface     !< flag parameter for natural land surfaces
+       LOGICAL, DIMENSION(:), ALLOCATABLE  ::  vegetation_surface  !< flag parameter for natural land surfaces
+
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  albedo            !< broadband albedo for each surface fraction (LSM: vegetation, water, pavement; USM: wall, green, window)
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  emissivity        !< emissivity of the surface, for each fraction  (LSM: vegetation, water, pavement; USM: wall, green, window)
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  frac              !< relative surface fraction (LSM: vegetation, water, pavement; USM: wall, green, window)
+
+       REAL(wp), DIMENSION(:), ALLOCATABLE   ::  aldif             !< albedo for longwave diffusive radiation, solar angle of 60Â°
+       REAL(wp), DIMENSION(:), ALLOCATABLE   ::  aldir             !< albedo for longwave direct radiation, solar angle of 60Â°
+       REAL(wp), DIMENSION(:), ALLOCATABLE   ::  asdif             !< albedo for shortwave diffusive radiation, solar angle of 60Â°
+       REAL(wp), DIMENSION(:), ALLOCATABLE   ::  asdir             !< albedo for shortwave direct radiation, solar angle of 60Â°
+       REAL(wp), DIMENSION(:), ALLOCATABLE   ::  rrtm_aldif        !< albedo for longwave diffusive radiation, solar angle of 60Â°
+       REAL(wp), DIMENSION(:), ALLOCATABLE   ::  rrtm_aldir        !< albedo for longwave direct radiation, solar angle of 60Â°
+       REAL(wp), DIMENSION(:), ALLOCATABLE   ::  rrtm_asdif        !< albedo for shortwave diffusive radiation, solar angle of 60Â°
+       REAL(wp), DIMENSION(:), ALLOCATABLE   ::  rrtm_asdir        !< albedo for shortwave direct radiation, solar angle of 60Â°
+
+       REAL(wp), DIMENSION(:), ALLOCATABLE   ::  pt_surface        !< skin-surface temperature
+       REAL(wp), DIMENSION(:), ALLOCATABLE   ::  rad_net           !< net radiation 
+       REAL(wp), DIMENSION(:), ALLOCATABLE   ::  rad_net_l         !< net radiation, used in USM
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  lambda_h          !< heat conductivity of soil/ wall (W/m/K) 
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  lambda_h_green    !< heat conductivity of green soil (W/m/K) 
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  lambda_h_window   !< heat conductivity of windows (W/m/K) 
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  lambda_h_def      !< default heat conductivity of soil (W/m/K)   
+
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  rad_lw_in           !< incoming longwave radiation
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  rad_lw_out          !< emitted longwave radiation
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  rad_sw_in           !< incoming shortwave radiation
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  rad_sw_out          !< emitted shortwave radiation
+       
+
 
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  c_liq               !< liquid water coverage (of vegetated area)
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  c_veg               !< vegetation coverage
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  f_sw_in             !< fraction of absorbed shortwave radiation by the surface layer (not implemented yet)
-       REAL(wp), DIMENSION(:), ALLOCATABLE ::  ghf              !< ground heat flux
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  ghf                 !< ground heat flux
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  g_d                 !< coefficient for dependence of r_canopy on water vapour pressure deficit
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  lai                 !< leaf area index
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  lambda_surface_u    !< coupling between surface and soil (depends on vegetation type) (W/m2/K)
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  lambda_surface_s    !< coupling between surface and soil (depends on vegetation type) (W/m2/K)
-       REAL(wp), DIMENSION(:), ALLOCATABLE ::  qsws_liq         !< surface flux of latent heat (liquid water portion)
-       REAL(wp), DIMENSION(:), ALLOCATABLE ::  qsws_soil        !< surface flux of latent heat (soil portion)
-       REAL(wp), DIMENSION(:), ALLOCATABLE ::  qsws_veg         !< surface flux of latent heat (vegetation portion)
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  qsws_liq            !< surface flux of latent heat (liquid water portion)
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  qsws_soil           !< surface flux of latent heat (soil portion)
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  qsws_veg            !< surface flux of latent heat (vegetation portion)
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  r_a                 !< aerodynamic resistance 
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  r_canopy            !< canopy resistance
@@ -224,12 +278,20 @@
        INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  surface_types   !< array of types of wall parameters
 
-       LOGICAL, DIMENSION(:), ALLOCATABLE  ::  isroof_surf         !< flag indication roof surfaces
-
-       REAL(wp), DIMENSION(:), ALLOCATABLE ::  albedo_surf         !< albedo of the surface
+       LOGICAL, DIMENSION(:), ALLOCATABLE  ::  isroof_surf          !< flag indicating roof surfaces
+       LOGICAL, DIMENSION(:), ALLOCATABLE  ::  ground_level         !< flag indicating ground floor level surfaces 
+
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  target_temp_summer  !< indoor target temperature summer
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  target_temp_winter  !< indoor target temperature summer        
+
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  c_surface           !< heat capacity of the wall surface skin (J/m2/K)
-       REAL(wp), DIMENSION(:), ALLOCATABLE ::  emiss_surf          !< emissivity of the wall surface
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  c_surface_green     !< heat capacity of the green surface skin (J/m2/K)
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  c_surface_window    !< heat capacity of the window surface skin (J/m2/K)
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  lambda_surf         !< heat conductivity between air and surface (W/m2/K)
-       REAL(wp), DIMENSION(:), ALLOCATABLE ::  roughness_wall      !< roughness relative to concrete
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  lambda_surf_green   !< heat conductivity between air and green surface (W/m2/K)
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  lambda_surf_window  !< heat conductivity between air and window surface (W/m2/K)
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  thickness_wall      !< thickness of the wall, roof and soil layers
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  thickness_green     !< thickness of the green wall, roof and soil layers
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  thickness_window    !< thickness of the window wall, roof and soil layers
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  transmissivity      !< transmissivity of windows
 
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  surfoutsl           !< reflected shortwave radiation for local surface in i-th reflection
@@ -238,14 +300,16 @@
 
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  tt_surface_m        !< surface temperature tendency (K)
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  tt_surface_window_m !< window surface temperature tendency (K)
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  tt_surface_green_m  !< green surface temperature tendency (K)
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  wshf                !< kinematic wall heat flux of sensible heat (actually no longer needed)
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  wshf_eb             !< wall heat flux of sensible heat in wall normal direction
 
-
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  wghf_eb             !< wall ground heat flux
-
-       REAL(wp), DIMENSION(:), ALLOCATABLE ::  rad_in_sw           !< incoming shortwave radiation
-       REAL(wp), DIMENSION(:), ALLOCATABLE ::  rad_out_sw          !< emitted shortwave radiation
-       REAL(wp), DIMENSION(:), ALLOCATABLE ::  rad_in_lw           !< incoming longwave radiation
-       REAL(wp), DIMENSION(:), ALLOCATABLE ::  rad_out_lw          !< emitted longwave radiation
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  wghf_eb_window      !< window ground heat flux
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  wghf_eb_green       !< green ground heat flux
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  iwghf_eb            !< indoor wall ground heat flux
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  iwghf_eb_window     !< indoor window ground heat flux
+
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  rad_lw_out_change_0
 
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  surfinsw            !< shortwave radiation falling to local surface including radiation from reflections
@@ -262,4 +326,18 @@
        REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  tt_wall_m         !< t_wall prognostic array 
        REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  zw                !< wall layer depths (m)
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  rho_c_window      !< volumetric heat capacity of the window material ( J m-3 K-1 ) (= 2.19E6)
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  dz_window         !< window grid spacing (center-center)
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ddz_window        !< 1/dz_window
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  dz_window_stag    !< window grid spacing (edge-edge)
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ddz_window_stag   !< 1/dz_window_stag
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  tt_window_m       !< t_window prognostic array 
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  zw_window         !< window layer depths (m)
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  rho_c_green       !< volumetric heat capacity of the green material ( J m-3 K-1 ) (= 2.19E6)
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  dz_green          !< green grid spacing (center-center)
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ddz_green         !< 1/dz_green
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  dz_green_stag     !< green grid spacing (edge-edge)
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ddz_green_stag    !< 1/dz_green_stag
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  tt_green_m        !< t_green prognostic array 
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  zw_green          !< green layer depths (m)
 
 
@@ -279,8 +357,18 @@
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  surfhf_av        !< average of total radiation flux incoming to minus outgoing from local surface  
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  wghf_eb_av       !< average of wghf_eb
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  wghf_eb_window_av  !< average of wghf_eb window
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  wghf_eb_green_av   !< average of wghf_eb window
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  iwghf_eb_av        !< indoor average of wghf_eb
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  iwghf_eb_window_av !< indoor average of wghf_eb window
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  wshf_eb_av       !< average of wshf_eb
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  t_surf_av        !< average of wall surface temperature (K)
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  t_surf_window_av !< average of window surface temperature (K)
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  t_surf_green_av  !< average of green wall surface temperature (K)
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  t_surf_whole_av  !< average of whole wall surface temperature (K)
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  t_surf_10cm_av   !< average of the near surface temperature (K)
 
        REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  t_wall_av      !< Average of t_wall
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  t_window_av    !< Average of t_window
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  t_green_av     !< Average of t_green
 
     END TYPE surf_type
@@ -305,4 +393,5 @@
     INTERFACE get_topography_top_index
        MODULE PROCEDURE get_topography_top_index
+       MODULE PROCEDURE get_topography_top_index_ji
     END  INTERFACE get_topography_top_index
 
@@ -331,4 +420,9 @@
     END INTERFACE surface_last_actions
 
+    INTERFACE surface_restore_elements
+       MODULE PROCEDURE surface_restore_elements_1d
+       MODULE PROCEDURE surface_restore_elements_2d
+    END INTERFACE surface_restore_elements
+
 !
 !-- Public variables
@@ -338,6 +432,7 @@
 !-- Public subroutines and functions
     PUBLIC get_topography_top_index, init_bc, init_surfaces,                   &
-           init_surface_arrays, surface_read_restart_data,                     &
-           surface_write_restart_data, surface_last_actions
+           init_surface_arrays, surface_read_restart_data,                     & 
+           surface_restore_elements, surface_write_restart_data,               &
+           surface_last_actions
 
 
@@ -473,4 +568,6 @@
        INTEGER(iwp), DIMENSION(0:3) ::  num_usm_v !< number of vertically-aligned urban surfaces 
 
+       LOGICAL ::  building                       !< flag indicating building grid point
+       LOGICAL ::  terrain                        !< flag indicating natural terrain grid point
 
        num_def_h = 0
@@ -481,4 +578,10 @@
        num_usm_v = 0
 !
+!--    Surfaces are classified according to the input data read from static
+!--    input file. If no input file is present, all surfaces are classified
+!--    either as natural, urban, or default, depending on the setting of 
+!--    land_surface and urban_surface. To control this, use the control
+!--    flag topo_no_distinct
+!
 !--    Count number of horizontal surfaces on local domain 
        DO  i = nxl, nxr
@@ -491,17 +594,34 @@
 !--                Check if grid point adjoins to any upward-facing horizontal
 !--                surface, e.g. the Earth surface, plane roofs, or ceilings.
+
                    IF ( .NOT. BTEST( wall_flags_0(k-1,j,i), 0 ) )  THEN
 !
+!--                   Determine flags indicating terrain or building. 
+                      terrain  = BTEST( wall_flags_0(k-1,j,i), 5 )  .OR.       &
+                                 topo_no_distinct
+                      building = BTEST( wall_flags_0(k-1,j,i), 6 )  .OR.       &
+                                 topo_no_distinct
+!
 !--                   Land-surface type
-                      IF ( land_surface )  THEN
+                      IF ( land_surface  .AND.  terrain )  THEN
                          num_lsm_h    = num_lsm_h    + 1 
 !
 !--                   Urban surface tpye
-                      ELSEIF ( urban_surface )  THEN 
+                      ELSEIF ( urban_surface  .AND.  building )  THEN
                          num_usm_h    = num_usm_h    + 1 
 !
 !--                   Default-surface type
-                      ELSE
-                         num_def_h(0) = num_def_h(0) + 1 
+                      ELSEIF ( .NOT. land_surface    .AND.                     &
+                               .NOT. urban_surface )  THEN
+                               
+                         num_def_h(0) = num_def_h(0) + 1
+!
+!--                   Unclassifified surface-grid point. Give error message.
+                      ELSE 
+                         WRITE( message_string, * )                           &
+                                          'Unclassified upward-facing ' //    &
+                                          'surface element at '//             &
+                                          'grid point (k,j,i) = ', k, j, i
+                         CALL message( 'surface_mod', 'PA0999', 1, 2, 0, 6, 0 )
                       ENDIF
 
@@ -531,10 +651,29 @@
 !--                Northward-facing
                    IF ( .NOT. BTEST( wall_flags_0(k,j-1,i), 0 ) )  THEN
-                      IF ( urban_surface )  THEN
+!
+!--                   Determine flags indicating terrain or building
+
+                      terrain  = BTEST( wall_flags_0(k,j-1,i), 5 )  .OR.       &
+                                 topo_no_distinct
+                      building = BTEST( wall_flags_0(k,j-1,i), 6 )   .OR.       &
+                                 topo_no_distinct
+                      IF (  land_surface  .AND.  terrain )  THEN
+                         num_lsm_v(0) = num_lsm_v(0) + 1 
+                      ELSEIF ( urban_surface  .AND.  building )  THEN
                          num_usm_v(0) = num_usm_v(0) + 1 
-                      ELSEIF ( land_surface )  THEN
-                         num_lsm_v(0) = num_lsm_v(0) + 1 
-                      ELSE
+!
+!--                   Default-surface type
+                      ELSEIF ( .NOT. land_surface    .AND.                     &
+                               .NOT. urban_surface )  THEN
                          num_def_v(0) = num_def_v(0) + 1 
+!
+!--                   Unclassifified surface-grid point. Give error message.
+                      ELSE 
+                         WRITE( message_string, * )                           &
+                                          'Unclassified northward-facing ' // &
+                                          'surface element at '//             &
+                                          'grid point (k,j,i) = ', k, j, i
+                         CALL message( 'surface_mod', 'PA0999', 1, 2, 0, 6, 0 ) 
+
                       ENDIF
                    ENDIF
@@ -542,10 +681,28 @@
 !--                Southward-facing
                    IF ( .NOT. BTEST( wall_flags_0(k,j+1,i), 0 ) )  THEN
-                      IF ( urban_surface )  THEN
+!
+!--                   Determine flags indicating terrain or building
+                      terrain  = BTEST( wall_flags_0(k,j+1,i), 5 )  .OR.       &
+                                 topo_no_distinct
+                      building = BTEST( wall_flags_0(k,j+1,i), 6 )  .OR.       &
+                                 topo_no_distinct
+                      IF (  land_surface  .AND.  terrain )  THEN
+                         num_lsm_v(1) = num_lsm_v(1) + 1 
+                      ELSEIF ( urban_surface  .AND.  building )  THEN
                          num_usm_v(1) = num_usm_v(1) + 1 
-                      ELSEIF ( land_surface )  THEN
-                         num_lsm_v(1) = num_lsm_v(1) + 1 
-                      ELSE
+!
+!--                   Default-surface type
+                      ELSEIF ( .NOT. land_surface    .AND.                     &
+                               .NOT. urban_surface )  THEN
                          num_def_v(1) = num_def_v(1) + 1 
+!
+!--                   Unclassifified surface-grid point. Give error message.
+                      ELSE 
+                         WRITE( message_string, * )                           &
+                                          'Unclassified southward-facing ' // &
+                                          'surface element at '//             &
+                                          'grid point (k,j,i) = ', k, j, i
+                         CALL message( 'surface_mod', 'PA0999', 1, 2, 0, 6, 0 ) 
+
                       ENDIF
                    ENDIF
@@ -553,10 +710,28 @@
 !--                Eastward-facing
                    IF ( .NOT. BTEST( wall_flags_0(k,j,i-1), 0 ) )  THEN
-                      IF ( urban_surface )  THEN
+!
+!--                   Determine flags indicating terrain or building
+                      terrain  = BTEST( wall_flags_0(k,j,i-1), 5 )  .OR.       &
+                                 topo_no_distinct
+                      building = BTEST( wall_flags_0(k,j,i-1), 6 )  .OR.       &
+                                 topo_no_distinct
+                      IF (  land_surface  .AND.  terrain )  THEN
+                         num_lsm_v(2) = num_lsm_v(2) + 1 
+                      ELSEIF ( urban_surface  .AND.  building )  THEN
                          num_usm_v(2) = num_usm_v(2) + 1 
-                      ELSEIF ( land_surface )  THEN
-                         num_lsm_v(2) = num_lsm_v(2) + 1 
-                      ELSE
+!
+!--                   Default-surface type
+                      ELSEIF ( .NOT. land_surface    .AND.                     &
+                               .NOT. urban_surface )  THEN
                          num_def_v(2) = num_def_v(2) + 1 
+!
+!--                   Unclassifified surface-grid point. Give error message.
+                      ELSE 
+                         WRITE( message_string, * )                           &
+                                          'Unclassified eastward-facing ' //  &
+                                          'surface element at '//             &
+                                          'grid point (k,j,i) = ', k, j, i
+                         CALL message( 'surface_mod', 'PA0999', 1, 2, 0, 6, 0 ) 
+
                       ENDIF
                    ENDIF
@@ -564,10 +739,28 @@
 !--                Westward-facing
                    IF ( .NOT. BTEST( wall_flags_0(k,j,i+1), 0 ) )  THEN
-                      IF ( urban_surface )  THEN
-                         num_usm_v(3) = num_usm_v(3) + 1
-                      ELSEIF ( land_surface )  THEN
-                         num_lsm_v(3) = num_lsm_v(3) + 1  
-                      ELSE
+!
+!--                   Determine flags indicating terrain or building
+                      terrain  = BTEST( wall_flags_0(k,j,i+1), 5 )  .OR.       &
+                                 topo_no_distinct
+                      building = BTEST( wall_flags_0(k,j,i+1), 6 )  .OR.       &
+                                 topo_no_distinct
+                      IF (  land_surface  .AND.  terrain )  THEN
+                         num_lsm_v(3) = num_lsm_v(3) + 1 
+                      ELSEIF ( urban_surface  .AND.  building )  THEN
+                         num_usm_v(3) = num_usm_v(3) + 1 
+!
+!--                   Default-surface type
+                      ELSEIF ( .NOT. land_surface    .AND.                     &
+                               .NOT. urban_surface )  THEN
                          num_def_v(3) = num_def_v(3) + 1 
+!
+!--                   Unclassifified surface-grid point. Give error message.
+                      ELSE 
+                         WRITE( message_string, * )                           &
+                                          'Unclassified westward-facing ' //  &
+                                          'surface element at '//             &
+                                          'grid point (k,j,i) = ', k, j, i
+                         CALL message( 'surface_mod', 'PA0999', 1, 2, 0, 6, 0 ) 
+
                       ENDIF
                    ENDIF
@@ -651,5 +844,5 @@
 !--    Default type.
        DO  l = 0, 3
-          CALL allocate_surface_attributes_v ( surf_def_v(l), .FALSE.,         &
+          CALL allocate_surface_attributes_v ( surf_def_v(l),                  &
                                                nys, nyn, nxl, nxr )
        ENDDO
@@ -657,5 +850,5 @@
 !--    Natural type
        DO  l = 0, 3
-          CALL allocate_surface_attributes_v ( surf_lsm_v(l), .TRUE.,          &
+          CALL allocate_surface_attributes_v ( surf_lsm_v(l),                  &
                                                nys, nyn, nxl, nxr )
        ENDDO
@@ -663,5 +856,5 @@
 !--    Urban type
        DO  l = 0, 3
-          CALL allocate_surface_attributes_v ( surf_usm_v(l), .FALSE.,         &
+          CALL allocate_surface_attributes_v ( surf_usm_v(l),                  &
                                                nys, nyn, nxl, nxr )
        ENDDO
@@ -716,5 +909,4 @@
 !--    Surface-parallel wind velocity
        ALLOCATE ( surfaces%uvw_abs(1:surfaces%ns) )
-!      ALLOCATE ( surfaces%pt_surface(1:surfaces%ns) )
 !
 !--    Roughness
@@ -746,4 +938,7 @@
        ALLOCATE ( surfaces%shf(1:surfaces%ns) )    
 !
+!--    surface temperature
+       ALLOCATE ( surfaces%pt_surface(1:surfaces%ns) ) 
+!
 !--    Characteristic humidity and surface flux of latent heat
        IF ( humidity )  THEN
@@ -758,10 +953,16 @@
        ENDIF 
 !
-!--    When cloud physics is used, arrays for storing potential temperature and
-!--    specific humidity at first grid level are required. 
-       IF ( cloud_physics  .OR.  cloud_droplets )  THEN
-          ALLOCATE ( surfaces%pt1(1:surfaces%ns) )
-          ALLOCATE ( surfaces%qv1(1:surfaces%ns) )
-       ENDIF
+!--    Scaling parameter (cs*) and surface flux of chemical species
+#if defined ( __chem )
+       IF ( air_chemistry )  THEN
+          ALLOCATE ( surfaces%css(1:nvar,1:surfaces%ns)   )   
+          ALLOCATE ( surfaces%cssws(1:nvar,1:surfaces%ns) ) 
+       ENDIF 
+#endif 
+!
+!--    Arrays for storing potential temperature and
+!--    specific humidity at first grid level
+       ALLOCATE ( surfaces%pt1(1:surfaces%ns) )
+       ALLOCATE ( surfaces%qv1(1:surfaces%ns) )
 !
 !--       
@@ -836,4 +1037,11 @@
        ENDIF 
 !
+!--    Chemical species flux
+#if defined( __chem )
+       IF ( air_chemistry )  THEN
+          ALLOCATE ( surfaces%cssws(1:nvar,1:surfaces%ns) ) 
+       ENDIF 
+#endif 
+!
 !--       
        IF ( cloud_physics .AND. microphysics_morrison)  THEN
@@ -858,5 +1066,5 @@
 !> Allocating memory for vertical surface types. 
 !------------------------------------------------------------------------------!
-    SUBROUTINE allocate_surface_attributes_v( surfaces, lsm,                   &
+    SUBROUTINE allocate_surface_attributes_v( surfaces,                        &
                                               nys_l, nyn_l, nxl_l, nxr_l )
 
@@ -867,6 +1075,4 @@
        INTEGER(iwp) ::  nxl_l  !< west bound of local 2d array start/end_index, is equal to nyn, except for restart-array
        INTEGER(iwp) ::  nxr_l  !< east bound of local 2d array start/end_index, is equal to nyn, except for restart-array
-
-       LOGICAL         ::  lsm      !< flag indicating data type of natural land surface
 
        TYPE(surf_type) ::  surfaces !< respective surface type
@@ -909,10 +1115,9 @@
        ALLOCATE ( surfaces%us(1:surfaces%ns) )
 !
-!--    Allocate Obukhov length and bulk Richardson number. Only required 
+!--    Allocate Obukhov length and bulk Richardson number. Actually, at
+!--    vertical surfaces these are only required for natural surfaces.  
 !--    for natural land surfaces
-       IF ( lsm )  THEN
-          ALLOCATE( surfaces%ol(1:surfaces%ns)  ) 
-          ALLOCATE( surfaces%rib(1:surfaces%ns) ) 
-       ENDIF
+       ALLOCATE( surfaces%ol(1:surfaces%ns)  ) 
+       ALLOCATE( surfaces%rib(1:surfaces%ns) ) 
 !
 !--    Allocate arrays for surface momentum fluxes for u and v. For u at north- 
